<?php

$aggregator_server = "antani";
//$aggregator_server = "192.168.1.210:8080";
//$aggregator_server = "192.168.1.120:8080";

function aggregator_login($username, $password)
{
    global $aggregator_server;

    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_VERBOSE, 1);
    curl_setopt($curl, CURLOPT_HEADER, 1);
    curl_setopt($curl, CURLOPT_POST, 1);
    curl_setopt($curl, CURLOPT_POSTFIELDS, "username=$username&password=$password");
    curl_setopt($curl, CURLOPT_HTTPHEADER, array("Accept: application/json", "Content-Type: application/x-www-form-urlencoded"));
    curl_setopt($curl, CURLOPT_URL, "$aggregator_server/auth/login/");
    $response = curl_exec($curl);
    //echo "<b>$response</b>";
    //die($response);
    $headers = substr($response, 0, strpos($response, "\r\n\r\n"));
    $body = substr($response, strpos($response, "\r\n\r\n") + 4);
    preg_match('/^Authorized-By: (-?\\d+)\\s*$/m', $headers, $matches);
    $userUrl = json_decode($body, true)['hypermedia']['links'][0]['href'];
    
    preg_match('~^.+/(\d+)/?$~', $userUrl, $matches2);
    $userId = $matches2[1];
    return array("Authorized-By" => $matches[1], "User-Url" => $userUrl, "User-Id" => $userId);
}

function aggregator_register($username, $password)
{
    global $aggregator_server;

    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_VERBOSE, 1);
    curl_setopt($curl, CURLOPT_HEADER, 1);
    curl_setopt($curl, CURLOPT_POST, 1);
    curl_setopt($curl, CURLOPT_POSTFIELDS, "username=$username&password=$password");
    curl_setopt($curl, CURLOPT_HTTPHEADER, array("Accept: application/json", "Content-Type: application/x-www-form-urlencoded"));
    curl_setopt($curl, CURLOPT_URL, "$aggregator_server/auth/register/");
    curl_exec($curl);
}

function aggregator_logout($authorizedBy)
{
    global $aggregator_server;

    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_VERBOSE, 1);
    curl_setopt($curl, CURLOPT_HEADER, 1);
    curl_setopt($curl, CURLOPT_POST, 1);
    curl_setopt($curl, CURLOPT_HTTPHEADER, array("Accept: application/json", "Authorized-By: $authorizedBy"));
    curl_setopt($curl, CURLOPT_URL, "$aggregator_server/auth/logout/");
    curl_exec($curl);
}

// TODO: Aggregator logout

function aggregator_getuser($authorizedBy, $userId)
{
    global $aggregator_server;

    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_VERBOSE, 1);
    curl_setopt($curl, CURLOPT_HEADER, 1);
    curl_setopt($curl, CURLOPT_HTTPGET, 1);
    curl_setopt($curl, CURLOPT_HTTPHEADER, array("Accept: application/json", "Authorized-By: $authorizedBy"));
    curl_setopt($curl, CURLOPT_URL, "$aggregator_server/users/$userId");
    $response = curl_exec($curl);
    $headers = substr($response, 0, strpos($response, "\r\n\r\n"));
    $body = substr($response, strpos($response, "\r\n\r\n") + 4);
    $user = json_decode($body, true);
    return $user;
}

/* ********** GOALS **************/

function aggregator_addgoal($authorizedBy, $condition, $goal)
{
    global $aggregator_server;

    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_VERBOSE, 1);
    curl_setopt($curl, CURLOPT_HEADER, 1);
    curl_setopt($curl, CURLOPT_POST, 1);
    curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($goal));
    curl_setopt($curl, CURLOPT_HTTPHEADER, array("Accept: application/json", "Authorized-By: $authorizedBy", "Content-Type: application/json"));
    curl_setopt($curl, CURLOPT_URL, "$aggregator_server/conditions/$condition/goals/new");
    curl_exec($curl);
}

function aggregator_getgoals($authorizedBy, $condition)
{
    global $aggregator_server;

    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_VERBOSE, 1);
    curl_setopt($curl, CURLOPT_HEADER, 1);
    curl_setopt($curl, CURLOPT_HTTPGET, 1);
    curl_setopt($curl, CURLOPT_HTTPHEADER, array("Accept: application/json", "Authorized-By: $authorizedBy"));
    curl_setopt($curl, CURLOPT_URL, "$aggregator_server/conditions/$condition/goals/");
    $response = curl_exec($curl);
    $headers = substr($response, 0, strpos($response, "\r\n\r\n"));
    $body = substr($response, strpos($response, "\r\n\r\n") + 4);
    $goals = json_decode($body, true);
    return $goals;
}

function aggregator_deletegoal($authorizedBy, $condition, $goalId)
{
    global $aggregator_server;

    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_VERBOSE, 1);
    curl_setopt($curl, CURLOPT_HEADER, 1);
    //curl_setopt($curl, CURLOPT_POST, 1);
    curl_setopt($curl, CURLOPT_HTTPGET, 1);
    curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "DELETE");
    curl_setopt($curl, CURLOPT_HTTPHEADER, array("Accept: application/json", "Authorized-By: $authorizedBy"));
    curl_setopt($curl, CURLOPT_URL, "$aggregator_server/conditions/$condition/goals/$goalId/delete");
    curl_exec($curl);
}

/* ********** REMINDERS **************/

function aggregator_addreminder($authorizedBy, $condition, $reminder)
{
    global $aggregator_server;

    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_VERBOSE, 1);
    curl_setopt($curl, CURLOPT_HEADER, 1);
    curl_setopt($curl, CURLOPT_POST, 1);
    curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($reminder));
    curl_setopt($curl, CURLOPT_HTTPHEADER, array("Accept: application/json", "Authorized-By: $authorizedBy", "Content-Type: application/json"));
    curl_setopt($curl, CURLOPT_URL, "$aggregator_server/conditions/$condition/reminders/new");

    curl_exec($curl);
}

function aggregator_getreminders($authorizedBy, $condition)
{
    global $aggregator_server;

    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_VERBOSE, 1);
    curl_setopt($curl, CURLOPT_HEADER, 1);
    curl_setopt($curl, CURLOPT_HTTPGET, 1);
    curl_setopt($curl, CURLOPT_HTTPHEADER, array("Accept: application/json", "Authorized-By: $authorizedBy"));
    curl_setopt($curl, CURLOPT_URL, "$aggregator_server/conditions/$condition/reminders/");
    $response = curl_exec($curl);
    $headers = substr($response, 0, strpos($response, "\r\n\r\n"));
    $body = substr($response, strpos($response, "\r\n\r\n") + 4);
    $reminders = json_decode($body, true);
    return $reminders;
}

function aggregator_deletereminder($authorizedBy, $condition, $reminderId)
{
    global $aggregator_server;

    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_VERBOSE, 1);
    curl_setopt($curl, CURLOPT_HEADER, 1);
    //curl_setopt($curl, CURLOPT_POST, 1);
    curl_setopt($curl, CURLOPT_HTTPGET, 1);
    curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "DELETE");
    curl_setopt($curl, CURLOPT_HTTPHEADER, array("Accept: application/json", "Authorized-By: $authorizedBy"));
    curl_setopt($curl, CURLOPT_URL, "$aggregator_server/conditions/$condition/reminders/$reminderId/delete");
    curl_exec($curl);
}

/* ********** CONDITIONS **************/

function aggregator_addcondition($authorizedBy, $condition)
{
    global $aggregator_server;

    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_VERBOSE, 1);
    curl_setopt($curl, CURLOPT_HEADER, 1);
    curl_setopt($curl, CURLOPT_POST, 1);
    curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($condition));
    curl_setopt($curl, CURLOPT_HTTPHEADER, array("Accept: application/json", "Authorized-By: $authorizedBy", "Content-Type: application/json"));
    curl_setopt($curl, CURLOPT_URL, "$aggregator_server/conditions/new");
    curl_exec($curl);
}

function aggregator_getconditions()
{
    global $aggregator_server;

    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_VERBOSE, 1);
    curl_setopt($curl, CURLOPT_HEADER, 1);
    curl_setopt($curl, CURLOPT_HTTPGET, 1);
    curl_setopt($curl, CURLOPT_HTTPHEADER, array("Accept: application/json"));
    curl_setopt($curl, CURLOPT_URL, "$aggregator_server/conditions/");
    $response = curl_exec($curl);
    $headers = substr($response, 0, strpos($response, "\r\n\r\n"));
    $body = substr($response, strpos($response, "\r\n\r\n") + 4);
    $conditions = json_decode($body, true);
    return $conditions;
}

function aggregator_deletecondition($authorizedBy, $conditionValue)
{
    global $aggregator_server;

    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_VERBOSE, 1);
    curl_setopt($curl, CURLOPT_HEADER, 1);
    //curl_setopt($curl, CURLOPT_POST, 1);
    curl_setopt($curl, CURLOPT_HTTPGET, 1);
    curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "DELETE");
    curl_setopt($curl, CURLOPT_HTTPHEADER, array("Accept: application/json", "Authorized-By: $authorizedBy"));
    curl_setopt($curl, CURLOPT_URL, "$aggregator_server/conditions/$conditionValue/delete");
    curl_exec($curl);
}

/* ********** EDUCATIONALS **************/

function aggregator_addeducational($authorizedBy, $condition, $notification)
{
    global $aggregator_server;

    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_VERBOSE, 1);
    curl_setopt($curl, CURLOPT_HEADER, 1);
    curl_setopt($curl, CURLOPT_POST, 1);
    curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($notification));
    curl_setopt($curl, CURLOPT_HTTPHEADER, array("Accept: application/json", "Authorized-By: $authorizedBy", "Content-Type: application/json"));
    curl_setopt($curl, CURLOPT_URL, "$aggregator_server/conditions/$condition/educationals/new");
    //die("$aggregator_server/conditions/$condition/educationals/new" . json_encode($notification));
    $response = curl_exec($curl);
    $headers = substr($response, 0, strpos($response, "\r\n\r\n"));
    $body = substr($response, strpos($response, "\r\n\r\n") + 4);
    return $body;
}

function aggregator_geteducationals($authorizedBy, $condition)
{
    global $aggregator_server;

    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_VERBOSE, 1);
    curl_setopt($curl, CURLOPT_HEADER, 1);
    curl_setopt($curl, CURLOPT_HTTPGET, 1);
    curl_setopt($curl, CURLOPT_HTTPHEADER, array("Accept: application/json", "Authorized-By: $authorizedBy"));
    curl_setopt($curl, CURLOPT_URL, "$aggregator_server/conditions/$condition/educationals/");
    $response = curl_exec($curl);
    $headers = substr($response, 0, strpos($response, "\r\n\r\n"));
    $body = substr($response, strpos($response, "\r\n\r\n") + 4);
    $goals = json_decode($body, true);
    return $goals;
}

function aggregator_updateeducational($authorizedBy, $condition, $notification)
{
    global $aggregator_server;

    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_VERBOSE, 1);
    curl_setopt($curl, CURLOPT_HEADER, 1);
    curl_setopt($curl, CURLOPT_POST, 1);
    curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "PUT");
    //curl_setopt($curl, CURLOPT_PUT, 1);
    curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($notification));
    curl_setopt($curl, CURLOPT_HTTPHEADER, array("Accept: application/json", "Authorized-By: $authorizedBy", "Content-Type: application/json"));
    curl_setopt($curl, CURLOPT_URL, "$aggregator_server/conditions/$condition/educationals/" . $notification["id"] . "/update");
    //die(json_encode($notification));
    curl_exec($curl);
}

/* ********** SYMPTOMS **************/

function aggregator_addsymptom($authorizedBy, $condition, $symptom)
{
    global $aggregator_server;

    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_VERBOSE, 1);
    curl_setopt($curl, CURLOPT_HEADER, 1);
    curl_setopt($curl, CURLOPT_POST, 1);
    curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($symptom));
    curl_setopt($curl, CURLOPT_HTTPHEADER, array("Accept: application/json", "Authorized-By: $authorizedBy", "Content-Type: application/json"));
    curl_setopt($curl, CURLOPT_URL, "$aggregator_server/conditions/$condition/symptoms/new");
    $response = curl_exec($curl);
    $headers = substr($response, 0, strpos($response, "\r\n\r\n"));
    return $headers;
}

function aggregator_getsymptoms($authorizedBy, $condition)
{
    global $aggregator_server;

    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_VERBOSE, 1);
    curl_setopt($curl, CURLOPT_HEADER, 1);
    curl_setopt($curl, CURLOPT_HTTPGET, 1);
    curl_setopt($curl, CURLOPT_HTTPHEADER, array("Accept: application/json", "Authorized-By: $authorizedBy"));
    curl_setopt($curl, CURLOPT_URL, "$aggregator_server/conditions/$condition/symptoms/");
    $response = curl_exec($curl);
    $headers = substr($response, 0, strpos($response, "\r\n\r\n"));
    $body = substr($response, strpos($response, "\r\n\r\n") + 4);
    $symptoms = json_decode($body, true);
    return $symptoms;
}

function aggregator_deletesymptom($authorizedBy, $condition, $symptomId)
{
    global $aggregator_server;

    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_VERBOSE, 1);
    curl_setopt($curl, CURLOPT_HEADER, 1);
    //curl_setopt($curl, CURLOPT_POST, 1);
    curl_setopt($curl, CURLOPT_HTTPGET, 1);
    curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "DELETE");
    curl_setopt($curl, CURLOPT_HTTPHEADER, array("Accept: application/json", "Authorized-By: $authorizedBy"));
    curl_setopt($curl, CURLOPT_URL, "$aggregator_server/conditions/$condition/symptoms/$symptomId/delete");
    curl_exec($curl);
}

/* ********** WORKOUTS **************/

function aggregator_addworkout($authorizedBy, $condition, $workout)
{
    global $aggregator_server;

    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_VERBOSE, 1);
    curl_setopt($curl, CURLOPT_HEADER, 1);
    curl_setopt($curl, CURLOPT_POST, 1);
    curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($workout));
    curl_setopt($curl, CURLOPT_HTTPHEADER, array("Accept: application/json", "Authorized-By: $authorizedBy", "Content-Type: application/json"));
    curl_setopt($curl, CURLOPT_URL, "$aggregator_server/conditions/$condition/workouts/new");
    //die(curl_exec($curl));
    curl_exec($curl);
}

function aggregator_getworkouts($authorizedBy, $condition)
{
    global $aggregator_server;

    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_VERBOSE, 1);
    curl_setopt($curl, CURLOPT_HEADER, 1);
    curl_setopt($curl, CURLOPT_HTTPGET, 1);
    curl_setopt($curl, CURLOPT_HTTPHEADER, array("Accept: application/json", "Authorized-By: $authorizedBy"));
    curl_setopt($curl, CURLOPT_URL, "$aggregator_server/conditions/$condition/workouts/");
    $response = curl_exec($curl);
    $headers = substr($response, 0, strpos($response, "\r\n\r\n"));
    $body = substr($response, strpos($response, "\r\n\r\n") + 4);
    $workouts = json_decode($body, true);
    return $workouts;
}

function aggregator_deleteworkout($authorizedBy, $condition, $workoutId)
{
    global $aggregator_server;

    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_VERBOSE, 1);
    curl_setopt($curl, CURLOPT_HEADER, 1);
    //curl_setopt($curl, CURLOPT_POST, 1);
    curl_setopt($curl, CURLOPT_HTTPGET, 1);
    curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "DELETE");
    curl_setopt($curl, CURLOPT_HTTPHEADER, array("Accept: application/json", "Authorized-By: $authorizedBy"));
    curl_setopt($curl, CURLOPT_URL, "$aggregator_server/conditions/$condition/workouts/$workoutId/delete");
    curl_exec($curl);
}

?>
